KUBERNETES(1)

NAME

cloud-controller-manager -

SYNOPSIS

cloud-controller-manager [OPTIONS]

DESCRIPTION

The Cloud controller manager is a daemon that embeds the cloud specific control loops shipped with Kubernetes.

OPTIONS

--address=0.0.0.0
    The IP address on which to serve the insecure --port (set to 0.0.0.0 for all IPv4 interfaces and :: for all IPv6 interfaces).

--allocate-node-cidrs=false
    Should CIDRs for Pods be allocated and set on the cloud provider.

--allow-untagged-cloud=false
    Allow the cluster to run without the cluster-id on cloud instances. This is a legacy mode of operation and a cluster-id will be required in the future.

--alsologtostderr=false
    log to standard error as well as files

--authentication-kubeconfig=""
    kubeconfig file pointing at the 'core' kubernetes server with enough rights to create tokenaccessreviews.authentication.k8s.io. This is optional. If empty, all token requests are considered to be anonymous and no client CA is looked up in the cluster.

--authentication-skip-lookup=false
    If false, the authentication-kubeconfig will be used to lookup missing authentication configuration from the cluster.

--authentication-token-webhook-cache-ttl=10s
    The duration to cache responses from the webhook token authenticator.

--authentication-tolerate-lookup-failure=false
    If true, failures to look up missing authentication configuration from the cluster are not considered fatal. Note that this can result in authentication that treats all requests as anonymous.

--authorization-always-allow-paths=[/healthz]
    A list of HTTP paths to skip during authorization, i.e. these are authorized without contacting the 'core' kubernetes server.

--authorization-kubeconfig=""
    kubeconfig file pointing at the 'core' kubernetes server with enough rights to create subjectaccessreviews.authorization.k8s.io. This is optional. If empty, all requests not skipped by authorization are forbidden.

--authorization-webhook-cache-authorized-ttl=10s
    The duration to cache 'authorized' responses from the webhook authorizer.

--authorization-webhook-cache-unauthorized-ttl=10s
    The duration to cache 'unauthorized' responses from the webhook authorizer.

--azure-container-registry-config=""
    Path to the file containing Azure container registry configuration information.

--bind-address=0.0.0.0
    The IP address on which to listen for the --secure-port port. The associated interface(s) must be reachable by the rest of the cluster, and by CLI/web clients. If blank, all interfaces will be used (0.0.0.0 for all IPv4 interfaces and :: for all IPv6 interfaces).

--cert-dir=""
    The directory where the TLS certs are located. If --tls-cert-file and --tls-private-key-file are provided, this flag will be ignored.

--cidr-allocator-type="RangeAllocator"
    Type of CIDR allocator to use

--client-ca-file=""
    If set, any request presenting a client certificate signed by one of the authorities in the client-ca-file is authenticated with an identity corresponding to the CommonName of the client certificate.

--cloud-config=""
    The path to the cloud provider configuration file. Empty string for no configuration file.

--cloud-provider=""
    The provider for cloud services. Empty string for no provider.

--cloud-provider-gce-lb-src-cidrs=130.211.0.0/22,209.85.152.0/22,209.85.204.0/22,35.191.0.0/16
    CIDRs opened in GCE firewall for LB traffic proxy health checks

--cluster-cidr=""
    CIDR Range for Pods in cluster. Requires --allocate-node-cidrs to be true

--cluster-name="kubernetes"
    The instance prefix for the cluster.

--concurrent-service-syncs=1
    The number of services that are allowed to sync concurrently. Larger number = more responsive service management, but more CPU (and network) load

--configure-cloud-routes=true
    Should CIDRs allocated by allocate-node-cidrs be configured on the cloud provider.

--contention-profiling=false
    Enable lock contention profiling, if profiling is enabled

--controller-start-interval=0s
    Interval between starting controller managers.

--controllers=[]
    A list of controllers to enable. '' enables all on-by-default controllers, 'foo' enables the controller named 'foo', '-foo' disables the controller named 'foo'. All controllers: cloud-node, cloud-node-lifecycle, route, service Disabled-by-default controllers:

--external-cloud-volume-plugin=""
    The plugin to use when cloud provider is set to external. Can be empty, should only be set when cloud-provider is external. Currently used to allow node and volume controllers to work for in tree cloud providers.

--feature-gates=
    A set of key=value pairs that describe feature gates for alpha/experimental features. Options are: APIListChunking=true|false (BETA - default=true) APIResponseCompression=true|false (ALPHA - default=false) AllAlpha=true|false (ALPHA - default=false) AppArmor=true|false (BETA - default=true) AttachVolumeLimit=true|false (BETA - default=true) BalanceAttachedNodeVolumes=true|false (ALPHA - default=false) BlockVolume=true|false (BETA - default=true) BoundServiceAccountTokenVolume=true|false (ALPHA - default=false) CPUManager=true|false (BETA - default=true) CRIContainerLogRotation=true|false (BETA - default=true) CSIBlockVolume=true|false (BETA - default=true) CSIDriverRegistry=true|false (BETA - default=true) CSIInlineVolume=true|false (ALPHA - default=false) CSIMigration=true|false (ALPHA - default=false) CSIMigrationAWS=true|false (ALPHA - default=false) CSIMigrationGCE=true|false (ALPHA - default=false) CSIMigrationOpenStack=true|false (ALPHA - default=false) CSINodeInfo=true|false (BETA - default=true) CustomCPUCFSQuotaPeriod=true|false (ALPHA - default=false) CustomResourcePublishOpenAPI=true|false (ALPHA - default=false) CustomResourceSubresources=true|false (BETA - default=true) CustomResourceValidation=true|false (BETA - default=true) CustomResourceWebhookConversion=true|false (ALPHA - default=false) DebugContainers=true|false (ALPHA - default=false) DevicePlugins=true|false (BETA - default=true) DryRun=true|false (BETA - default=true) DynamicAuditing=true|false (ALPHA - default=false) DynamicKubeletConfig=true|false (BETA - default=true) ExpandCSIVolumes=true|false (ALPHA - default=false) ExpandInUsePersistentVolumes=true|false (ALPHA - default=false) ExpandPersistentVolumes=true|false (BETA - default=true) ExperimentalCriticalPodAnnotation=true|false (ALPHA - default=false) ExperimentalHostUserNamespaceDefaulting=true|false (BETA - default=false) HyperVContainer=true|false (ALPHA - default=false) KubeletPodResources=true|false (ALPHA - default=false) LocalStorageCapacityIsolation=true|false (BETA - default=true) MountContainers=true|false (ALPHA - default=false) NodeLease=true|false (BETA - default=true) PodShareProcessNamespace=true|false (BETA - default=true) ProcMountType=true|false (ALPHA - default=false) QOSReserved=true|false (ALPHA - default=false) ResourceLimitsPriorityFunction=true|false (ALPHA - default=false) ResourceQuotaScopeSelectors=true|false (BETA - default=true) RotateKubeletClientCertificate=true|false (BETA - default=true) RotateKubeletServerCertificate=true|false (BETA - default=true) RunAsGroup=true|false (BETA - default=true) RuntimeClass=true|false (BETA - default=true) SCTPSupport=true|false (ALPHA - default=false) ScheduleDaemonSetPods=true|false (BETA - default=true) ServerSideApply=true|false (ALPHA - default=false) ServiceNodeExclusion=true|false (ALPHA - default=false) StorageVersionHash=true|false (ALPHA - default=false) StreamingProxyRedirects=true|false (BETA - default=true) SupportNodePidsLimit=true|false (ALPHA - default=false) SupportPodPidsLimit=true|false (BETA - default=true) Sysctls=true|false (BETA - default=true) TTLAfterFinished=true|false (ALPHA - default=false) TaintBasedEvictions=true|false (BETA - default=true) TaintNodesByCondition=true|false (BETA - default=true) TokenRequest=true|false (BETA - default=true) TokenRequestProjection=true|false (BETA - default=true) ValidateProxyRedirects=true|false (BETA - default=true) VolumeSnapshotDataSource=true|false (ALPHA - default=false) VolumeSubpathEnvExpansion=true|false (ALPHA - default=false) WinDSR=true|false (ALPHA - default=false) WinOverlay=true|false (ALPHA - default=false) WindowsGMSA=true|false (ALPHA - default=false)

-h, --help=false
    help for cloud-controller-manager

--http2-max-streams-per-connection=0
    The limit that the server gives to clients for the maximum number of streams in an HTTP/2 connection. Zero means to use golang's default.

--kube-api-burst=30
    Burst to use while talking with kubernetes apiserver.

--kube-api-content-type="application/vnd.kubernetes.protobuf"
    Content type of requests sent to apiserver.

--kube-api-qps=20
    QPS to use while talking with kubernetes apiserver.

--kubeconfig=""
    Path to kubeconfig file with authorization and master location information.

--leader-elect=true
    Start a leader election client and gain leadership before executing the main loop. Enable this when running replicated components for high availability.

--leader-elect-lease-duration=15s
    The duration that non-leader candidates will wait after observing a leadership renewal until attempting to acquire leadership of a led but unrenewed leader slot. This is effectively the maximum duration that a leader can be stopped before it is replaced by another candidate. This is only applicable if leader election is enabled.

--leader-elect-renew-deadline=10s
    The interval between attempts by the acting master to renew a leadership slot before it stops leading. This must be less than or equal to the lease duration. This is only applicable if leader election is enabled.

--leader-elect-resource-lock="endpoints"
    The type of resource object that is used for locking during leader election. Supported options are endpoints (default) and configmaps.

--leader-elect-retry-period=2s
    The duration the clients should wait between attempting acquisition and renewal of a leadership. This is only applicable if leader election is enabled.

--log-backtrace-at=:0
    when logging hits line file:N, emit a stack trace

--log-dir=""
    If non-empty, write log files in this directory

--log-file=""
    If non-empty, use this log file

--log-flush-frequency=5s
    Maximum number of seconds between log flushes

--logtostderr=true
    log to standard error instead of files

--master=""
    The address of the Kubernetes API server (overrides any value in kubeconfig).

--min-resync-period=12h0m0s
    The resync period in reflectors will be random between MinResyncPeriod and 2*MinResyncPeriod.

--node-monitor-period=5s
    The period for syncing NodeStatus in NodeController.

--node-status-update-frequency=5m0s
    Specifies how often the controller updates nodes' status.

--node-sync-period=0s
    This flag is deprecated and will be removed in future releases. See node-monitor-period for Node health checking or route-reconciliation-period for cloud provider's route configuration settings.

--port=0
    The port on which to serve unsecured, unauthenticated access. Set to 0 to disable.

--profiling=false
    Enable profiling via web interface host:port/debug/pprof/

--requestheader-allowed-names=[]
    List of client certificate common names to allow to provide usernames in headers specified by --requestheader-username-headers. If empty, any client certificate validated by the authorities in --requestheader-client-ca-file is allowed.

--requestheader-client-ca-file=""
    Root certificate bundle to use to verify client certificates on incoming requests before trusting usernames in headers specified by --requestheader-username-headers. WARNING: generally do not depend on authorization being already done for incoming requests.

--requestheader-extra-headers-prefix=[x-remote-extra-]
    List of request header prefixes to inspect. X-Remote-Extra- is suggested.

--requestheader-group-headers=[x-remote-group]
    List of request headers to inspect for groups. X-Remote-Group is suggested.

--requestheader-username-headers=[x-remote-user]
    List of request headers to inspect for usernames. X-Remote-User is common.

--route-reconciliation-period=10s
    The period for reconciling routes created for Nodes by cloud provider.

--secure-port=10258
    The port on which to serve HTTPS with authentication and authorization.If 0, don't serve HTTPS at all.

--skip-headers=false
    If true, avoid header prefixes in the log messages

--stderrthreshold=2
    logs at or above this threshold go to stderr

--tls-cert-file=""
    File containing the default x509 Certificate for HTTPS. (CA cert, if any, concatenated after server cert). If HTTPS serving is enabled, and --tls-cert-file and --tls-private-key-file are not provided, a self-signed certificate and key are generated for the public address and saved to the directory specified by --cert-dir.

--tls-cipher-suites=[]
    Comma-separated list of cipher suites for the server. If omitted, the default Go cipher suites will be use. Possible values: TLS_ECDHE_ECDSA_WITH_AES_128_CBC_SHA,TLS_ECDHE_ECDSA_WITH_AES_128_CBC_SHA256,TLS_ECDHE_ECDSA_WITH_AES_128_GCM_SHA256,TLS_ECDHE_ECDSA_WITH_AES_256_CBC_SHA,TLS_ECDHE_ECDSA_WITH_AES_256_GCM_SHA384,TLS_ECDHE_ECDSA_WITH_CHACHA20_POLY1305,TLS_ECDHE_ECDSA_WITH_RC4_128_SHA,TLS_ECDHE_RSA_WITH_3DES_EDE_CBC_SHA,TLS_ECDHE_RSA_WITH_AES_128_CBC_SHA,TLS_ECDHE_RSA_WITH_AES_128_CBC_SHA256,TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256,TLS_ECDHE_RSA_WITH_AES_256_CBC_SHA,TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384,TLS_ECDHE_RSA_WITH_CHACHA20_POLY1305,TLS_ECDHE_RSA_WITH_RC4_128_SHA,TLS_RSA_WITH_3DES_EDE_CBC_SHA,TLS_RSA_WITH_AES_128_CBC_SHA,TLS_RSA_WITH_AES_128_CBC_SHA256,TLS_RSA_WITH_AES_128_GCM_SHA256,TLS_RSA_WITH_AES_256_CBC_SHA,TLS_RSA_WITH_AES_256_GCM_SHA384,TLS_RSA_WITH_RC4_128_SHA

--tls-min-version=""
    Minimum TLS version supported. Possible values: VersionTLS10, VersionTLS11, VersionTLS12

--tls-private-key-file=""
    File containing the default x509 private key matching --tls-cert-file.

--tls-sni-cert-key=[]
    A pair of x509 certificate and private key file paths, optionally suffixed with a list of domain patterns which are fully qualified domain names, possibly with prefixed wildcard segments. If no domain patterns are provided, the names of the certificate are extracted. Non-wildcard matches trump over wildcard matches, explicit domain patterns trump over extracted names. For multiple key/certificate pairs, use the --tls-sni-cert-key multiple times. Examples: "example.crt,example.key" or "foo.crt,foo.key:*.foo.com,foo.com".

--use-service-account-credentials=false
    If true, use individual service account credentials for each controller.

-v, --v=0
    number for the log level verbosity

--version=false
    Print version information and quit

--vmodule=
    comma-separated list of pattern=N settings for file-filtered logging

HISTORY

January 2015, Originally compiled by Eric Paris (eparis at redhat dot com) based on the kubernetes source material, but hopefully they have been automatically generated since!